/*  迭 ũ(length)  ˻Ѵ.
   true -   迭 (seq1, seq2) ũⰡ  
   false -  迭 ũⰡ ٸ  */
public  static boolean sameLength(double [] seq1, double [] seq2) {
    return ((seq1 != null)
    && (seq2 != null)
    && seq1.length == seq2.length);
}

/*  迭(seq1 seq2)   ˻Ѵ. 
   true -  迭 ũŰ ,    Ʈ ִ .
   false - ׷  . */
public  static boolean pairwiseEqual(double [] seq1, double [] seq2) {
    if (! sameLength(seq1, seq2)) { return false; }
    assert seq1 != null && seq2 != null;
    for (int i = 0 ; i < seq1.length ; i++) {
        if ((seq1[i] != seq2[i])) {
            return false;
        }
    }
    return true;
}

/* 迭 Ư Ʈ ϰ ִ ˻Ѵ.
   true - arr 迭  elt  ּ νϽ ִ 
   false - ׷   */
public static boolean eltsEqual(double [] arr, double elt) {
    if (arr == null) { return false; }
    for (int i = 0 ; i < arr.length ; i++) {
        if (arr[i] != elt) { return false; }
    }
    return true;
}

public static boolean eltsEqual(boolean [] arr, boolean elt) {
    if (arr == null) { return false; }
    for (int i = 0 ; i < arr.length ; i++) {
        if (arr[i] != elt) { return false; }
    }
    return true;
}

/* 迭 Ư Ʈ ϰ ִ ˻Ѵ.
   true - arr 迭  elt  ּ νϽ ִ 
   false - ׷   */
public static boolean memberOf(double elt, double [] arr) {
    if (arr == null) { return false; }
    for (int i = 0 ; i < arr.length ; i++) {
        if (arr[i] == elt) { return true; }
    }
    return false;
}

/* 迭 ũ⸦ Ѵ.*/
public static int size(double[] x) {
    if ( x == null) {
        return 0;
    }
    return x.length;
}
public static int size(int[] x) {
    if ( x == null) {
        return 0;
    }
    return x.length;
}

/*  迭  踦 Ѵ.
	true - seq1 seq2  (ĺ ; lexical order) ũų  
		   (: seq1=[1,2,1]̰ seq2=[1,1,1,1] , seq1 seq2 ũ.)
	false - seq2 seq1   ū 
*/

public static boolean lexGTE(double [] seq1, double [] seq2) {
    if (seq1 == null) { return false; }
    if (seq2 == null) { return false; }
    int minlength = (seq1.length < seq2.length) ? seq1.length : seq2.length;
    for (int i = 0 ; i < minlength ; i++) {
        if (seq1[i] < seq2[i]) {
            return false;
        } else if (seq1[i] > seq2[i]) {
            return true;
        }
    }
    if (seq1.length < seq2.length) {
        return false;
    }
    return true;
}
/* 迭   Ư  ũų   ˻Ѵ.
    true - arr null ƴϰ arr  ׸ elt ũų  
	false - ׷  
*/

public static boolean eltsGTE(double  [] arr, double elt) {
    if (arr == null) { return false; }
    for (int i = 0 ; i < arr.length ; i++) {
        if (arr[i] < elt) { return false; }
    }
    return true;
}

/*  迭 κ  迡 ִ ˻Ѵ.
	true - seq1 null ƴϰ seq1 ִ   seq2 ִ 
	false - ׷   */

public static boolean subsetOf(double [] seq1, double [] seq2) {
    if (seq1 == null) { return false; }
    if (seq2 == null) { return false; }
    for (int i = 0 ; i < seq1.length ; i++) {
        if (!memberOf(seq1[i], seq2)) {
            return false;
        }
    }
    return true;
}

/*   ٻ   ˻Ѵ.
	true -   ̰ 0.01 ̸ 
	false - ׷  */
public static boolean fuzzyEq(double x, double y) {
    return  (Math.abs(x - y) < 0.01);
}
public static boolean fuzzyLTE(double x, double y) {
    return  (Math.abs(x - y) < 0.01) || x < y;
}

/*  迭  (revserse) ˻Ѵ.
     true  - seq1 seq2 ũⰡ  迭 ִ   ݴ 
	 false - ׷  
*/
public static boolean isReverse(double[] seq1, double[] seq2) {
    if (! sameLength(seq1, seq2)) { return false; }
    assert seq1 != null && seq2 != null; // because sameLength() = true
    int length = seq1.length;
    for (int i = 0 ; i < length ; i++) {
        if (!fuzzyEq(seq1[i], seq2[length - i - 1])) {
            return false;
        }
    }
    return true;
}
